/*!
 * This Source Code Form is subject to the terms of the Mozilla Public License,
 * v. 2.0. If a copy of the MPL was not distributed with this file, You can
 * obtain one at http://mozilla.org/MPL/2.0/.
 */

import type { Option as O } from "effect";

export type Multiplicity =
	| "single"
	| "optional"
	| "multiple"
	| "any"
	;

export namespace Multiplicity {
	export type With<M extends Multiplicity, T> = {
		single: T,
		optional: O.Option<T>,
		multiple: readonly [T, ...T[]],
		any: readonly T[],
	}[M];
}
